VTK: vtkInteractorStyle Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkInteractorStyle Class Reference

provide event-driven interface to the rendering window (defines trackball mode) More...

`#include <vtkInteractorStyle.h>`

Inheritance diagram for vtkInteractorStyle:
[legend]
Collaboration diagram for vtkInteractorStyle:
[legend]

## Public Types
typedef vtkInteractorObserver | Superclass
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkInteractorStyle * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetInteractor (vtkRenderWindowInteractor *interactor) override
| Set/Get the Interactor wrapper being controlled by this object. More...
void | SetEnabled (int) override
| Turn on/off this interactor. More...
void | FindPokedRenderer (int, int)
| When an event occurs, we must determine which Renderer the event occurred within, since one RenderWindow may contain multiple renderers. More...
virtual void | OnMouseMove ()
| Generic event bindings can be overridden in subclasses. More...
virtual void | OnLeftButtonDown ()
virtual void | OnLeftButtonUp ()
virtual void | OnMiddleButtonDown ()
virtual void | OnMiddleButtonUp ()
virtual void | OnRightButtonDown ()
virtual void | OnRightButtonUp ()
virtual void | OnLeftButtonDoubleClick ()
virtual void | OnMiddleButtonDoubleClick ()
virtual void | OnRightButtonDoubleClick ()
virtual void | OnMouseWheelForward ()
virtual void | OnMouseWheelBackward ()
virtual void | OnMouseWheelLeft ()
virtual void | OnMouseWheelRight ()
virtual void | OnFourthButtonDown ()
virtual void | OnFourthButtonUp ()
virtual void | OnFifthButtonDown ()
virtual void | OnFifthButtonUp ()
virtual void | OnMove3D (vtkEventData *)
| Generic 3D event bindings can be overridden in subclasses. More...
virtual void | OnButton3D (vtkEventData *)
virtual void | OnPick3D (vtkEventData *)
virtual void | OnClip3D (vtkEventData *)
virtual void | OnSelect3D (vtkEventData *)
virtual void | OnMenu3D (vtkEventData *)
virtual void | OnNextPose3D (vtkEventData *)
virtual void | OnPositionProp3D (vtkEventData *)
virtual void | OnViewerMovement3D (vtkEventData *)
virtual void | OnElevation3D (vtkEventData *)
void | OnChar () override
| OnChar is triggered when an ASCII key is pressed. More...
virtual void | OnKeyDown ()
virtual void | OnKeyUp ()
virtual void | OnKeyPress ()
virtual void | OnKeyRelease ()
virtual void | OnExpose ()
| These are more esoteric events, but are useful in some cases. More...
virtual void | OnConfigure ()
virtual void | OnEnter ()
virtual void | OnLeave ()
virtual void | OnTimer ()
| OnTimer calls Rotate, Rotate etc which should be overridden by style subclasses. More...
virtual void | Rotate ()
| These methods for the different interactions in different modes are overridden in subclasses to perform the correct motion. More...
virtual void | Spin ()
virtual void | Pan ()
virtual void | Dolly ()
virtual void | Zoom ()
virtual void | UniformScale ()
virtual void | EnvironmentRotate ()
virtual void | OnStartSwipe ()
| gesture based events More...
virtual void | OnSwipe ()
virtual void | OnEndSwipe ()
virtual void | OnStartPinch ()
virtual void | OnPinch ()
virtual void | OnEndPinch ()
virtual void | OnStartRotate ()
virtual void | OnRotate ()
virtual void | OnEndRotate ()
virtual void | OnStartPan ()
virtual void | OnPan ()
virtual void | OnEndPan ()
virtual void | OnTap ()
virtual void | OnLongTap ()
virtual void | OnDropLocation (double *vtkNotUsed(position))
| When the mouse location is updated while dragging files. More...
virtual void | OnDropFiles (vtkStringArray *vtkNotUsed(filePaths))
| When files are dropped on the render window. More...
void | DelegateTDxEvent (unsigned long event, void *calldata)
| Called by the callback to process 3DConnexion device events. More...
virtual void | SetAutoAdjustCameraClippingRange (vtkTypeBool)
| If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene. More...
virtual vtkTypeBool | GetAutoAdjustCameraClippingRange ()
| If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene. More...
virtual void | AutoAdjustCameraClippingRangeOn ()
| If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene. More...
virtual void | AutoAdjustCameraClippingRangeOff ()
| If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene. More...
virtual int | GetState ()
| Some useful information for interaction. More...
virtual vtkTypeBool | GetUseTimers ()
| Set/Get timer hint. More...
virtual void | SetUseTimers (vtkTypeBool)
| Set/Get timer hint. More...
virtual void | UseTimersOn ()
| Set/Get timer hint. More...
virtual void | UseTimersOff ()
| Set/Get timer hint. More...
virtual void | SetTimerDuration (unsigned long)
| If using timers, specify the default timer interval (in milliseconds). More...
virtual unsigned long | GetTimerDuration ()
| If using timers, specify the default timer interval (in milliseconds). More...
virtual void | SetHandleObservers (vtkTypeBool)
| Does ProcessEvents handle observers on this class or not. More...
virtual vtkTypeBool | GetHandleObservers ()
| Does ProcessEvents handle observers on this class or not. More...
virtual void | HandleObserversOn ()
| Does ProcessEvents handle observers on this class or not. More...
virtual void | HandleObserversOff ()
| Does ProcessEvents handle observers on this class or not. More...
virtual void | StartState (int newstate)
| utility routines used by state changes More...
virtual void | StopState ()
| utility routines used by state changes More...
virtual void | StartAnimate ()
| Interaction mode entry points used internally. More...
virtual void | StopAnimate ()
| Interaction mode entry points used internally. More...
virtual void | StartRotate ()
| Interaction mode entry points used internally. More...
virtual void | EndRotate ()
| Interaction mode entry points used internally. More...
virtual void | StartZoom ()
| Interaction mode entry points used internally. More...
virtual void | EndZoom ()
| Interaction mode entry points used internally. More...
virtual void | StartPan ()
| Interaction mode entry points used internally. More...
virtual void | EndPan ()
| Interaction mode entry points used internally. More...
virtual void | StartSpin ()
| Interaction mode entry points used internally. More...
virtual void | EndSpin ()
| Interaction mode entry points used internally. More...
virtual void | StartDolly ()
| Interaction mode entry points used internally. More...
virtual void | EndDolly ()
| Interaction mode entry points used internally. More...
virtual void | StartUniformScale ()
| Interaction mode entry points used internally. More...
virtual void | EndUniformScale ()
| Interaction mode entry points used internally. More...
virtual void | StartTimer ()
| Interaction mode entry points used internally. More...
virtual void | EndTimer ()
| Interaction mode entry points used internally. More...
virtual void | StartTwoPointer ()
| Interaction mode entry points used internally. More...
virtual void | EndTwoPointer ()
| Interaction mode entry points used internally. More...
virtual void | StartGesture ()
| Interaction mode entry points used internally. More...
virtual void | EndGesture ()
| Interaction mode entry points used internally. More...
virtual void | StartEnvRotate ()
| Interaction mode entry points used internally. More...
virtual void | EndEnvRotate ()
| Interaction mode entry points used internally. More...
virtual void | HighlightProp (vtkProp *prop)
| When picking successfully selects an actor, this method highlights the picked prop appropriately. More...
virtual void | HighlightActor2D (vtkActor2D *actor2D)
| When picking successfully selects an actor, this method highlights the picked prop appropriately. More...
virtual void | HighlightProp3D (vtkProp3D *prop3D)
| When picking successfully selects an actor, this method highlights the picked prop appropriately. More...
virtual void | SetPickColor (double, double, double)
| Set/Get the pick color (used by default to color vtkActor2D's). More...
virtual void | SetPickColor (double[3])
| Set/Get the pick color (used by default to color vtkActor2D's). More...
virtual double * | GetPickColor ()
| Set/Get the pick color (used by default to color vtkActor2D's). More...
virtual void | GetPickColor (double data[3])
| Set/Get the pick color (used by default to color vtkActor2D's). More...
virtual void | SetMouseWheelMotionFactor (double)
| Set/Get the mouse wheel motion factor. More...
virtual double | GetMouseWheelMotionFactor ()
| Set/Get the mouse wheel motion factor. More...
virtual vtkTDxInteractorStyle * | GetTDxStyle ()
| 3Dconnexion device interactor style. More...
virtual void | SetTDxStyle (vtkTDxInteractorStyle *tdxStyle)
| 3Dconnexion device interactor style. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual void | SetPriority (float)
| Set/Get the priority at which events are processed. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkInteractorStyle * | New ()
| This class must be supplied with a vtkRenderWindowInteractor wrapper or parent. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorStyle * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkInteractorStyle ()
| ~vtkInteractorStyle () override
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
virtual void | RegisterPickers ()
| Register internal Pickers in the Picking Manager. More...
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Main process event method. More...
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
int | State
int | AnimState
vtkTypeBool | HandleObservers
vtkTypeBool | UseTimers
int | TimerId
vtkTypeBool | AutoAdjustCameraClippingRange
vtkOutlineSource * | Outline
vtkPolyDataMapper * | OutlineMapper
vtkActor * | OutlineActor
vtkRenderer * | PickedRenderer
vtkProp * | CurrentProp
vtkActor2D * | PickedActor2D
int | PropPicked
double | PickColor [3]
double | MouseWheelMotionFactor
unsigned long | TimerDuration
vtkEventForwarderCommand * | EventForwarder
vtkTDxInteractorStyle * | TDxStyle
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

provide event-driven interface to the rendering window (defines trackball mode)

vtkInteractorStyle is a base class implementing the majority of motion control routines and defines an event driven interface to support vtkRenderWindowInteractor. vtkRenderWindowInteractor implements platform dependent key/mouse routing and timer control, which forwards events in a neutral form to vtkInteractorStyle.

vtkInteractorStyle implements the "joystick" style of interaction. That is, holding down the mouse keys generates a stream of events that cause continuous actions (e.g., rotate, translate, pan, zoom). (The class vtkInteractorStyleTrackball implements a grab and move style.) The event bindings for this class include the following:

- Keypress j / Keypress t: toggle between joystick (position sensitive) and trackball (motion sensitive) styles. In joystick style, motion occurs continuously as long as a mouse button is pressed. In trackball style, motion occurs when the mouse button is pressed and the mouse pointer moves.
- Keypress c / Keypress a: toggle between camera and actor modes. In camera mode, mouse events affect the camera position and focal point. In actor mode, mouse events affect the actor that is under the mouse pointer.
- Button 1: rotate the camera around its focal point (if camera mode) or rotate the actor around its origin (if actor mode). The rotation is in the direction defined from the center of the renderer's viewport towards the mouse position. In joystick mode, the magnitude of the rotation is determined by the distance the mouse is from the center of the render window.
- Button 2: pan the camera (if camera mode) or translate the actor (if actor mode). In joystick mode, the direction of pan or translation is from the center of the viewport towards the mouse position. In trackball mode, the direction of motion is the direction the mouse moves. (Note: with 2-button mice, pan is defined as <Shift>-Button 1.)
- Button 3: zoom the camera (if camera mode) or scale the actor (if actor mode). Zoom in/increase scale if the mouse position is in the top half of the viewport; zoom out/decrease scale if the mouse position is in the bottom half. In joystick mode, the amount of zoom is controlled by the distance of the mouse pointer from the horizontal centerline of the window.
- Keypress 3: toggle the render window into and out of stereo mode. By default, red-blue stereo pairs are created. Some systems support Crystal Eyes LCD stereo glasses; you have to invoke SetStereoTypeToCrystalEyes() on the rendering window.
- Keypress e: exit the application.
- Keypress f: fly to the picked point
- Keypress p: perform a pick operation. The render window interactor has an internal instance of vtkCellPicker that it uses to pick.
- Keypress r: reset the camera view along the current view direction. Centers the actors and moves the camera so that all actors are visible.
- Keypress s: modify the representation of all actors so that they are surfaces.
- Keypress u: invoke the user-defined function. Typically, this keypress will bring up an interactor that you can type commands in. Typing u calls UserCallBack() on the vtkRenderWindowInteractor, which invokes a vtkCommand::UserEvent. In other words, to define a user-defined callback, just add an observer to the vtkCommand::UserEvent on the vtkRenderWindowInteractor object.
- Keypress w: modify the representation of all actors so that they are wireframe.

vtkInteractorStyle can be subclassed to provide new interaction styles and a facility to override any of the default mouse/key operations which currently handle trackball or joystick styles is provided. Note that this class will fire a variety of events that can be watched using an observer, such as LeftButtonPressEvent, LeftButtonReleaseEvent, MiddleButtonPressEvent, MiddleButtonReleaseEvent, RightButtonPressEvent, RightButtonReleaseEvent, EnterEvent, LeaveEvent, KeyPressEvent, KeyReleaseEvent, CharEvent, ExposeEvent, ConfigureEvent, TimerEvent, MouseMoveEvent,

See also
  vtkInteractorStyleTrackball

Events:
  vtkCommand::CharEvent vtkCommand::ConfigureEvent vtkCommand::DisableEvent vtkCommand::DropFilesEvent vtkCommand::EnableEvent vtkCommand::EndInteractionEvent vtkCommand::EndPanEvent vtkCommand::EndPinchEvent vtkCommand::EndRotateEvent vtkCommand::EndSwipeEvent vtkCommand::EnterEvent vtkCommand::ExposeEvent vtkCommand::FifthButtonPressEvent vtkCommand::FifthButtonReleaseEvent vtkCommand::FourthButtonPressEvent vtkCommand::FourthButtonReleaseEvent vtkCommand::KeyPressEvent vtkCommand::KeyReleaseEvent vtkCommand::LeaveEvent vtkCommand::LeftButtonPressEvent vtkCommand::LeftButtonReleaseEvent vtkCommand::LongTapEvent vtkCommand::MiddleButtonPressEvent vtkCommand::MiddleButtonReleaseEvent vtkCommand::MouseMoveEvent vtkCommand::MouseWheelBackwardEvent vtkCommand::MouseWheelForwardEvent vtkCommand::MouseWheelLeftEvent vtkCommand::MouseWheelRightEvent vtkCommand::PanEvent vtkCommand::PinchEvent vtkCommand::RightButtonPressEvent vtkCommand::RightButtonReleaseEvent vtkCommand::RotateEvent vtkCommand::StartInteractionEvent vtkCommand::StartPanEvent vtkCommand::StartPinchEvent vtkCommand::StartRotateEvent vtkCommand::StartSwipeEvent vtkCommand::SwipeEvent vtkCommand::TapEvent vtkCommand::TimerEvent vtkCommand::UpdateDropLocationEvent

Examples:
  vtkInteractorStyle (Examples)

Online Examples:

Tests:
  vtkInteractorStyle (Tests)

Definition at line 147 of file vtkInteractorStyle.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkInteractorObserver vtkInteractorStyle::Superclass

Definition at line 157 of file vtkInteractorStyle.h.

## Constructor & Destructor Documentation

## ◆ vtkInteractorStyle()

vtkInteractorStyle::vtkInteractorStyle | ( |  | ) |
| protected

## ◆ ~vtkInteractorStyle()

vtkInteractorStyle::~vtkInteractorStyle | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkInteractorStyle* vtkInteractorStyle::New | ( |  | ) |
| static

This class must be supplied with a vtkRenderWindowInteractor wrapper or parent.

This class should not normally be instantiated by application programmers.

## ◆ IsTypeOf()

static vtkTypeBool vtkInteractorStyle::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkInteractorStyle::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkInteractorStyleTreeMapHover, vtkInteractorStyleAreaSelectHover, vtkContextInteractorStyle, vtkZSpaceInteractorStyle, vtkVRInteractorStyle, vtkOSPRayTestInteractor, vtkOpenXRInteractorStyle, vtkOpenVRInteractorStyle, vtkInteractorStyleSwitchBase, vtkInteractorStyle3D, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleUnicam, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTrackball, vtkInteractorStyleTerrain, vtkInteractorStyleSwitch, vtkInteractorStyleRubberBandZoom, vtkInteractorStyleRubberBandPick, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleMultiTouchCamera, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, vtkInteractorStyleFlight, and vtkInteractorStyleDrawPolygon.

## ◆ SafeDownCast()

static vtkInteractorStyle* vtkInteractorStyle::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkInteractorStyle::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkInteractorStyleTreeMapHover, vtkInteractorStyleAreaSelectHover, vtkContextInteractorStyle, vtkZSpaceInteractorStyle, vtkVRInteractorStyle, vtkOSPRayTestInteractor, vtkOpenXRInteractorStyle, vtkOpenVRInteractorStyle, vtkInteractorStyleSwitchBase, vtkInteractorStyle3D, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleUnicam, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTrackball, vtkInteractorStyleTerrain, vtkInteractorStyleSwitch, vtkInteractorStyleRubberBandZoom, vtkInteractorStyleRubberBandPick, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleMultiTouchCamera, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, vtkInteractorStyleFlight, and vtkInteractorStyleDrawPolygon.

## ◆ NewInstance()

vtkInteractorStyle* vtkInteractorStyle::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkInteractorStyle::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkInteractorStyleTreeMapHover, vtkInteractorStyleAreaSelectHover, vtkContextInteractorStyle, vtkZSpaceInteractorStyle, vtkVRInteractorStyle, vtkInteractorStyleSwitchBase, and vtkInteractorStyle3D.

## ◆ SetInteractor()

void vtkInteractorStyle::SetInteractor | ( | vtkRenderWindowInteractor * | interactor | ) |
| overridevirtual

Set/Get the Interactor wrapper being controlled by this object.

(Satisfy superclass API.)

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkInteractorStyleTreeMapHover, vtkInteractorStyleAreaSelectHover, and vtkVRInteractorStyle.

## ◆ SetEnabled()

void vtkInteractorStyle::SetEnabled | ( | int |  | ) |
| overridevirtual

Turn on/off this interactor.

Interactor styles operate a little bit differently than other types of interactor observers. When the SetInteractor() method is invoked, the automatically enable themselves. This is a legacy requirement, and convenient for the user.

Reimplemented from vtkInteractorObserver.

## ◆ SetAutoAdjustCameraClippingRange()

virtual void vtkInteractorStyle::SetAutoAdjustCameraClippingRange | ( | vtkTypeBool |  | ) |
| virtual

If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene.

Clipping will still occur if objects in the scene are behind the camera or come very close. If AutoAdjustCameraClippingRange is off, no adjustment will be made per render, but the camera clipping range will still be reset when the camera is reset.

Reimplemented in vtkInteractorStyleSwitch.

## ◆ GetAutoAdjustCameraClippingRange()

virtual vtkTypeBool vtkInteractorStyle::GetAutoAdjustCameraClippingRange | ( |  | ) |
| virtual

If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene.

Clipping will still occur if objects in the scene are behind the camera or come very close. If AutoAdjustCameraClippingRange is off, no adjustment will be made per render, but the camera clipping range will still be reset when the camera is reset.

## ◆ AutoAdjustCameraClippingRangeOn()

virtual void vtkInteractorStyle::AutoAdjustCameraClippingRangeOn | ( |  | ) |
| virtual

If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene.

Clipping will still occur if objects in the scene are behind the camera or come very close. If AutoAdjustCameraClippingRange is off, no adjustment will be made per render, but the camera clipping range will still be reset when the camera is reset.

## ◆ AutoAdjustCameraClippingRangeOff()

virtual void vtkInteractorStyle::AutoAdjustCameraClippingRangeOff | ( |  | ) |
| virtual

If AutoAdjustCameraClippingRange is on, then before each render the camera clipping range will be adjusted to "fit" the whole scene.

Clipping will still occur if objects in the scene are behind the camera or come very close. If AutoAdjustCameraClippingRange is off, no adjustment will be made per render, but the camera clipping range will still be reset when the camera is reset.

## ◆ FindPokedRenderer()

void vtkInteractorStyle::FindPokedRenderer | ( | int | ,
|  | int |
| ) |  |

When an event occurs, we must determine which Renderer the event occurred within, since one RenderWindow may contain multiple renderers.

## ◆ GetState()

virtual int vtkInteractorStyle::GetState | ( |  | ) |
| virtual

Some useful information for interaction.

## ◆ GetUseTimers()

virtual vtkTypeBool vtkInteractorStyle::GetUseTimers | ( |  | ) |
| virtual

Set/Get timer hint.

## ◆ SetUseTimers()

virtual void vtkInteractorStyle::SetUseTimers | ( | vtkTypeBool |  | ) |
| virtual

Set/Get timer hint.

## ◆ UseTimersOn()

virtual void vtkInteractorStyle::UseTimersOn | ( |  | ) |
| virtual

Set/Get timer hint.

## ◆ UseTimersOff()

virtual void vtkInteractorStyle::UseTimersOff | ( |  | ) |
| virtual

Set/Get timer hint.

## ◆ SetTimerDuration()

virtual void vtkInteractorStyle::SetTimerDuration | ( | unsigned long |  | ) |
| virtual

If using timers, specify the default timer interval (in milliseconds).

Care must be taken when adjusting the timer interval from the default value of 10 milliseconds–it may adversely affect the interactors.

## ◆ GetTimerDuration()

virtual unsigned long vtkInteractorStyle::GetTimerDuration | ( |  | ) |
| virtual

If using timers, specify the default timer interval (in milliseconds).

Care must be taken when adjusting the timer interval from the default value of 10 milliseconds–it may adversely affect the interactors.

## ◆ SetHandleObservers()

virtual void vtkInteractorStyle::SetHandleObservers | ( | vtkTypeBool |  | ) |
| virtual

Does ProcessEvents handle observers on this class or not.

## ◆ GetHandleObservers()

virtual vtkTypeBool vtkInteractorStyle::GetHandleObservers | ( |  | ) |
| virtual

Does ProcessEvents handle observers on this class or not.

## ◆ HandleObserversOn()

virtual void vtkInteractorStyle::HandleObserversOn | ( |  | ) |
| virtual

Does ProcessEvents handle observers on this class or not.

## ◆ HandleObserversOff()

virtual void vtkInteractorStyle::HandleObserversOff | ( |  | ) |
| virtual

Does ProcessEvents handle observers on this class or not.

## ◆ OnMouseMove()

virtual void vtkInteractorStyle::OnMouseMove | ( |  | ) |
| inlinevirtual

Generic event bindings can be overridden in subclasses.

Reimplemented in vtkInteractorStyleTreeMapHover, vtkInteractorStyleAreaSelectHover, vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleUnicam, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBandZoom, vtkInteractorStyleRubberBandPick, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, vtkInteractorStyleFlight, and vtkInteractorStyleDrawPolygon.

Definition at line 235 of file vtkInteractorStyle.h.

## ◆ OnLeftButtonDown()

virtual void vtkInteractorStyle::OnLeftButtonDown | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleUnicam, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBandZoom, vtkInteractorStyleRubberBandPick, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, vtkInteractorStyleFlight, and vtkInteractorStyleDrawPolygon.

Definition at line 236 of file vtkInteractorStyle.h.

## ◆ OnLeftButtonUp()

virtual void vtkInteractorStyle::OnLeftButtonUp | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleTreeMapHover, vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleUnicam, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBandZoom, vtkInteractorStyleRubberBandPick, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, vtkInteractorStyleFlight, and vtkInteractorStyleDrawPolygon.

Definition at line 237 of file vtkInteractorStyle.h.

## ◆ OnMiddleButtonDown()

virtual void vtkInteractorStyle::OnMiddleButtonDown | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, and vtkInteractorStyleFlight.

Definition at line 238 of file vtkInteractorStyle.h.

## ◆ OnMiddleButtonUp()

virtual void vtkInteractorStyle::OnMiddleButtonUp | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, and vtkInteractorStyleFlight.

Definition at line 239 of file vtkInteractorStyle.h.

## ◆ OnRightButtonDown()

virtual void vtkInteractorStyle::OnRightButtonDown | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, and vtkInteractorStyleFlight.

Definition at line 240 of file vtkInteractorStyle.h.

## ◆ OnRightButtonUp()

virtual void vtkInteractorStyle::OnRightButtonUp | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, vtkInteractorStyleJoystickCamera, vtkInteractorStyleJoystickActor, vtkInteractorStyleImage, and vtkInteractorStyleFlight.

Definition at line 241 of file vtkInteractorStyle.h.

## ◆ OnLeftButtonDoubleClick()

virtual void vtkInteractorStyle::OnLeftButtonDoubleClick | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle.

Definition at line 242 of file vtkInteractorStyle.h.

## ◆ OnMiddleButtonDoubleClick()

virtual void vtkInteractorStyle::OnMiddleButtonDoubleClick | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle.

Definition at line 243 of file vtkInteractorStyle.h.

## ◆ OnRightButtonDoubleClick()

virtual void vtkInteractorStyle::OnRightButtonDoubleClick | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle.

Definition at line 244 of file vtkInteractorStyle.h.

## ◆ OnMouseWheelForward()

virtual void vtkInteractorStyle::OnMouseWheelForward | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, and vtkInteractorStyleJoystickCamera.

Definition at line 245 of file vtkInteractorStyle.h.

## ◆ OnMouseWheelBackward()

virtual void vtkInteractorStyle::OnMouseWheelBackward | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkInteractorStyleUser, vtkInteractorStyleTrackballCamera, vtkInteractorStyleRubberBand3D, vtkInteractorStyleRubberBand2D, and vtkInteractorStyleJoystickCamera.

Definition at line 246 of file vtkInteractorStyle.h.

## ◆ OnMouseWheelLeft()

virtual void vtkInteractorStyle::OnMouseWheelLeft | ( |  | ) |
| inlinevirtual

Definition at line 247 of file vtkInteractorStyle.h.

## ◆ OnMouseWheelRight()

virtual void vtkInteractorStyle::OnMouseWheelRight | ( |  | ) |
| inlinevirtual

Definition at line 248 of file vtkInteractorStyle.h.

## ◆ OnFourthButtonDown()

virtual void vtkInteractorStyle::OnFourthButtonDown | ( |  | ) |
| inlinevirtual

Definition at line 249 of file vtkInteractorStyle.h.

## ◆ OnFourthButtonUp()

virtual void vtkInteractorStyle::OnFourthButtonUp | ( |  | ) |
| inlinevirtual

Definition at line 250 of file vtkInteractorStyle.h.

## ◆ OnFifthButtonDown()

virtual void vtkInteractorStyle::OnFifthButtonDown | ( |  | ) |
| inlinevirtual

Definition at line 251 of file vtkInteractorStyle.h.

## ◆ OnFifthButtonUp()

virtual void vtkInteractorStyle::OnFifthButtonUp | ( |  | ) |
| inlinevirtual

Definition at line 252 of file vtkInteractorStyle.h.

## ◆ OnMove3D()

virtual void vtkInteractorStyle::OnMove3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Generic 3D event bindings can be overridden in subclasses.

Reimplemented in vtkZSpaceInteractorStyle, and vtkVRInteractorStyle.

Definition at line 257 of file vtkInteractorStyle.h.

## ◆ OnButton3D()

virtual void vtkInteractorStyle::OnButton3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Definition at line 258 of file vtkInteractorStyle.h.

## ◆ OnPick3D()

virtual void vtkInteractorStyle::OnPick3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkZSpaceInteractorStyle.

Definition at line 259 of file vtkInteractorStyle.h.

## ◆ OnClip3D()

virtual void vtkInteractorStyle::OnClip3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Definition at line 260 of file vtkInteractorStyle.h.

## ◆ OnSelect3D()

virtual void vtkInteractorStyle::OnSelect3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkZSpaceInteractorStyle, and vtkVRInteractorStyle.

Definition at line 261 of file vtkInteractorStyle.h.

## ◆ OnMenu3D()

virtual void vtkInteractorStyle::OnMenu3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle.

Definition at line 262 of file vtkInteractorStyle.h.

## ◆ OnNextPose3D()

virtual void vtkInteractorStyle::OnNextPose3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle.

Definition at line 263 of file vtkInteractorStyle.h.

## ◆ OnPositionProp3D()

virtual void vtkInteractorStyle::OnPositionProp3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkZSpaceInteractorStyle.

Definition at line 264 of file vtkInteractorStyle.h.

## ◆ OnViewerMovement3D()

virtual void vtkInteractorStyle::OnViewerMovement3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle.

Definition at line 265 of file vtkInteractorStyle.h.

## ◆ OnElevation3D()

virtual void vtkInteractorStyle::OnElevation3D | ( | vtkEventData * |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle.

Definition at line 266 of file vtkInteractorStyle.h.

## ◆ OnChar()

void vtkInteractorStyle::OnChar | ( |  | ) |
| overridevirtual

OnChar is triggered when an ASCII key is pressed.

Some basic key presses are handled here ('q' for Quit, 'p' for Pick, etc)

Reimplemented from vtkInteractorObserver.

Reimplemented in vtkContextInteractorStyle.

## ◆ OnKeyDown()

virtual void vtkInteractorStyle::OnKeyDown | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleFlight.

Definition at line 277 of file vtkInteractorStyle.h.

## ◆ OnKeyUp()

virtual void vtkInteractorStyle::OnKeyUp | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleFlight.

Definition at line 282 of file vtkInteractorStyle.h.

## ◆ OnKeyPress()

virtual void vtkInteractorStyle::OnKeyPress | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, vtkOSPRayTestInteractor, and vtkInteractorStyleUser.

Definition at line 287 of file vtkInteractorStyle.h.

## ◆ OnKeyRelease()

virtual void vtkInteractorStyle::OnKeyRelease | ( |  | ) |
| inlinevirtual

Reimplemented in vtkContextInteractorStyle, and vtkInteractorStyleUser.

Definition at line 292 of file vtkInteractorStyle.h.

## ◆ OnExpose()

virtual void vtkInteractorStyle::OnExpose | ( |  | ) |
| inlinevirtual

These are more esoteric events, but are useful in some cases.

Reimplemented in vtkInteractorStyleUser.

Definition at line 297 of file vtkInteractorStyle.h.

## ◆ OnConfigure()

virtual void vtkInteractorStyle::OnConfigure | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleUser.

Definition at line 298 of file vtkInteractorStyle.h.

## ◆ OnEnter()

virtual void vtkInteractorStyle::OnEnter | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleUser.

Definition at line 299 of file vtkInteractorStyle.h.

## ◆ OnLeave()

virtual void vtkInteractorStyle::OnLeave | ( |  | ) |
| inlinevirtual

Reimplemented in vtkParallelCoordinatesInteractorStyle, and vtkInteractorStyleUser.

Definition at line 300 of file vtkInteractorStyle.h.

## ◆ OnTimer()

virtual void vtkInteractorStyle::OnTimer | ( |  | ) |
| virtual

OnTimer calls Rotate, Rotate etc which should be overridden by style subclasses.

Reimplemented in vtkInteractorStyleUser, vtkInteractorStyleUnicam, and vtkInteractorStyleFlight.

## ◆ Rotate()

virtual void vtkInteractorStyle::Rotate | ( |  | ) |
| inlinevirtual

These methods for the different interactions in different modes are overridden in subclasses to perform the correct motion.

Since they might be called from OnTimer, they do not have mouse coord parameters (use interactor's GetEventPosition and GetLastEventPosition)

Reimplemented in vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleJoystickCamera, and vtkInteractorStyleJoystickActor.

Definition at line 314 of file vtkInteractorStyle.h.

## ◆ Spin()

virtual void vtkInteractorStyle::Spin | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleJoystickCamera, and vtkInteractorStyleJoystickActor.

Definition at line 315 of file vtkInteractorStyle.h.

## ◆ Pan()

virtual void vtkInteractorStyle::Pan | ( |  | ) |
| inlinevirtual

Reimplemented in vtkParallelCoordinatesInteractorStyle, vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleJoystickCamera, and vtkInteractorStyleJoystickActor.

Definition at line 316 of file vtkInteractorStyle.h.

## ◆ Dolly()

virtual void vtkInteractorStyle::Dolly | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleTrackballCamera, vtkInteractorStyleTrackballActor, vtkInteractorStyleTerrain, vtkInteractorStyleJoystickCamera, and vtkInteractorStyleJoystickActor.

Definition at line 317 of file vtkInteractorStyle.h.

## ◆ Zoom()

virtual void vtkInteractorStyle::Zoom | ( |  | ) |
| inlinevirtual

Reimplemented in vtkParallelCoordinatesInteractorStyle, and vtkInteractorStyleRubberBandZoom.

Definition at line 318 of file vtkInteractorStyle.h.

## ◆ UniformScale()

virtual void vtkInteractorStyle::UniformScale | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleTrackballActor, and vtkInteractorStyleJoystickActor.

Definition at line 319 of file vtkInteractorStyle.h.

## ◆ EnvironmentRotate()

virtual void vtkInteractorStyle::EnvironmentRotate | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleTrackballCamera.

Definition at line 320 of file vtkInteractorStyle.h.

## ◆ OnStartSwipe()

virtual void vtkInteractorStyle::OnStartSwipe | ( |  | ) |
| inlinevirtual

gesture based events

Definition at line 325 of file vtkInteractorStyle.h.

## ◆ OnSwipe()

virtual void vtkInteractorStyle::OnSwipe | ( |  | ) |
| inlinevirtual

Definition at line 326 of file vtkInteractorStyle.h.

## ◆ OnEndSwipe()

virtual void vtkInteractorStyle::OnEndSwipe | ( |  | ) |
| inlinevirtual

Definition at line 327 of file vtkInteractorStyle.h.

## ◆ OnStartPinch()

virtual void vtkInteractorStyle::OnStartPinch | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 328 of file vtkInteractorStyle.h.

## ◆ OnPinch()

virtual void vtkInteractorStyle::OnPinch | ( |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle, and vtkInteractorStyleMultiTouchCamera.

Definition at line 329 of file vtkInteractorStyle.h.

## ◆ OnEndPinch()

virtual void vtkInteractorStyle::OnEndPinch | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 330 of file vtkInteractorStyle.h.

## ◆ OnStartRotate()

virtual void vtkInteractorStyle::OnStartRotate | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 331 of file vtkInteractorStyle.h.

## ◆ OnRotate()

virtual void vtkInteractorStyle::OnRotate | ( |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle, and vtkInteractorStyleMultiTouchCamera.

Definition at line 332 of file vtkInteractorStyle.h.

## ◆ OnEndRotate()

virtual void vtkInteractorStyle::OnEndRotate | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 333 of file vtkInteractorStyle.h.

## ◆ OnStartPan()

virtual void vtkInteractorStyle::OnStartPan | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 334 of file vtkInteractorStyle.h.

## ◆ OnPan()

virtual void vtkInteractorStyle::OnPan | ( |  | ) |
| inlinevirtual

Reimplemented in vtkVRInteractorStyle, and vtkInteractorStyleMultiTouchCamera.

Definition at line 335 of file vtkInteractorStyle.h.

## ◆ OnEndPan()

virtual void vtkInteractorStyle::OnEndPan | ( |  | ) |
| inlinevirtual

Reimplemented in vtkInteractorStyleMultiTouchCamera.

Definition at line 336 of file vtkInteractorStyle.h.

## ◆ OnTap()

virtual void vtkInteractorStyle::OnTap | ( |  | ) |
| inlinevirtual

Definition at line 337 of file vtkInteractorStyle.h.

## ◆ OnLongTap()

virtual void vtkInteractorStyle::OnLongTap | ( |  | ) |
| inlinevirtual

Definition at line 338 of file vtkInteractorStyle.h.

## ◆ StartState()

virtual void vtkInteractorStyle::StartState | ( | int | newstate | ) |
| virtual

utility routines used by state changes

## ◆ StopState()

virtual void vtkInteractorStyle::StopState | ( |  | ) |
| virtual

utility routines used by state changes

## ◆ StartAnimate()

virtual void vtkInteractorStyle::StartAnimate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StopAnimate()

virtual void vtkInteractorStyle::StopAnimate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartRotate()

virtual void vtkInteractorStyle::StartRotate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndRotate()

virtual void vtkInteractorStyle::EndRotate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartZoom()

virtual void vtkInteractorStyle::StartZoom | ( |  | ) |
| virtual

Interaction mode entry points used internally.

Reimplemented in vtkParallelCoordinatesInteractorStyle.

## ◆ EndZoom()

virtual void vtkInteractorStyle::EndZoom | ( |  | ) |
| virtual

Interaction mode entry points used internally.

Reimplemented in vtkParallelCoordinatesInteractorStyle.

## ◆ StartPan()

virtual void vtkInteractorStyle::StartPan | ( |  | ) |
| virtual

Interaction mode entry points used internally.

Reimplemented in vtkParallelCoordinatesInteractorStyle.

## ◆ EndPan()

virtual void vtkInteractorStyle::EndPan | ( |  | ) |
| virtual

Interaction mode entry points used internally.

Reimplemented in vtkParallelCoordinatesInteractorStyle.

## ◆ StartSpin()

virtual void vtkInteractorStyle::StartSpin | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndSpin()

virtual void vtkInteractorStyle::EndSpin | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartDolly()

virtual void vtkInteractorStyle::StartDolly | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndDolly()

virtual void vtkInteractorStyle::EndDolly | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartUniformScale()

virtual void vtkInteractorStyle::StartUniformScale | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndUniformScale()

virtual void vtkInteractorStyle::EndUniformScale | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartTimer()

virtual void vtkInteractorStyle::StartTimer | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndTimer()

virtual void vtkInteractorStyle::EndTimer | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartTwoPointer()

virtual void vtkInteractorStyle::StartTwoPointer | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndTwoPointer()

virtual void vtkInteractorStyle::EndTwoPointer | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartGesture()

virtual void vtkInteractorStyle::StartGesture | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndGesture()

virtual void vtkInteractorStyle::EndGesture | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ StartEnvRotate()

virtual void vtkInteractorStyle::StartEnvRotate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ EndEnvRotate()

virtual void vtkInteractorStyle::EndEnvRotate | ( |  | ) |
| virtual

Interaction mode entry points used internally.

## ◆ OnDropLocation()

virtual void vtkInteractorStyle::OnDropLocation | ( | double * | vtkNotUsedposition | ) |
| inlinevirtual

When the mouse location is updated while dragging files.

The argument contains the position relative to the window of the mouse where the files are dropped. It is called before OnDropFiles.

Definition at line 382 of file vtkInteractorStyle.h.

## ◆ OnDropFiles()

virtual void vtkInteractorStyle::OnDropFiles | ( | vtkStringArray * | vtkNotUsedfilePaths | ) |
| inlinevirtual

When files are dropped on the render window.

The argument contains the list of file paths dropped. It is called after OnDropLocation.

Definition at line 389 of file vtkInteractorStyle.h.

## ◆ HighlightProp()

virtual void vtkInteractorStyle::HighlightProp | ( | vtkProp * | prop | ) |
| virtual

When picking successfully selects an actor, this method highlights the picked prop appropriately.

Currently this is done by placing a bounding box around a picked vtkProp3D, and using the PickColor to highlight a vtkProp2D.

## ◆ HighlightActor2D()

virtual void vtkInteractorStyle::HighlightActor2D | ( | vtkActor2D * | actor2D | ) |
| virtual

When picking successfully selects an actor, this method highlights the picked prop appropriately.

Currently this is done by placing a bounding box around a picked vtkProp3D, and using the PickColor to highlight a vtkProp2D.

## ◆ HighlightProp3D()

virtual void vtkInteractorStyle::HighlightProp3D | ( | vtkProp3D * | prop3D | ) |
| virtual

When picking successfully selects an actor, this method highlights the picked prop appropriately.

Currently this is done by placing a bounding box around a picked vtkProp3D, and using the PickColor to highlight a vtkProp2D.

## ◆ SetPickColor() [1/2]

virtual void vtkInteractorStyle::SetPickColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the pick color (used by default to color vtkActor2D's).

The color is expressed as red/green/blue values between (0.0,1.0).

## ◆ SetPickColor() [2/2]

virtual void vtkInteractorStyle::SetPickColor | ( | double | [3] | ) |
| virtual

Set/Get the pick color (used by default to color vtkActor2D's).

The color is expressed as red/green/blue values between (0.0,1.0).

## ◆ GetPickColor() [1/2]

virtual double* vtkInteractorStyle::GetPickColor | ( |  | ) |
| virtual

Set/Get the pick color (used by default to color vtkActor2D's).

The color is expressed as red/green/blue values between (0.0,1.0).

## ◆ GetPickColor() [2/2]

virtual void vtkInteractorStyle::GetPickColor | ( | double | data[3] | ) |
| virtual

Set/Get the pick color (used by default to color vtkActor2D's).

The color is expressed as red/green/blue values between (0.0,1.0).

## ◆ SetMouseWheelMotionFactor()

virtual void vtkInteractorStyle::SetMouseWheelMotionFactor | ( | double |  | ) |
| virtual

Set/Get the mouse wheel motion factor.

Default to 1.0. Set it to a different value to emphasize or de-emphasize the action triggered by mouse wheel motion.

## ◆ GetMouseWheelMotionFactor()

virtual double vtkInteractorStyle::GetMouseWheelMotionFactor | ( |  | ) |
| virtual

Set/Get the mouse wheel motion factor.

Default to 1.0. Set it to a different value to emphasize or de-emphasize the action triggered by mouse wheel motion.

## ◆ GetTDxStyle()

virtual vtkTDxInteractorStyle* vtkInteractorStyle::GetTDxStyle | ( |  | ) |
| virtual

3Dconnexion device interactor style.

Initial value is a pointer to an object of class vtkTdxInteractorStyleCamera.

## ◆ SetTDxStyle()

virtual void vtkInteractorStyle::SetTDxStyle | ( | vtkTDxInteractorStyle * | tdxStyle | ) |
| virtual

3Dconnexion device interactor style.

Initial value is a pointer to an object of class vtkTdxInteractorStyleCamera.

## ◆ DelegateTDxEvent()

void vtkInteractorStyle::DelegateTDxEvent | ( | unsigned long | event,
|  | void * | calldata
| ) |  |

Called by the callback to process 3DConnexion device events.

## ◆ ProcessEvents()

static void vtkInteractorStyle::ProcessEvents | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

Main process event method.

## Member Data Documentation

## ◆ State

int vtkInteractorStyle::State
| protected

Definition at line 447 of file vtkInteractorStyle.h.

## ◆ AnimState

int vtkInteractorStyle::AnimState
| protected

Definition at line 448 of file vtkInteractorStyle.h.

## ◆ HandleObservers

vtkTypeBool vtkInteractorStyle::HandleObservers
| protected

Definition at line 451 of file vtkInteractorStyle.h.

## ◆ UseTimers

vtkTypeBool vtkInteractorStyle::UseTimers
| protected

Definition at line 452 of file vtkInteractorStyle.h.

## ◆ TimerId

int vtkInteractorStyle::TimerId
| protected

Definition at line 453 of file vtkInteractorStyle.h.

## ◆ AutoAdjustCameraClippingRange

vtkTypeBool vtkInteractorStyle::AutoAdjustCameraClippingRange
| protected

Definition at line 455 of file vtkInteractorStyle.h.

## ◆ Outline

vtkOutlineSource* vtkInteractorStyle::Outline
| protected

Definition at line 458 of file vtkInteractorStyle.h.

## ◆ OutlineMapper

vtkPolyDataMapper* vtkInteractorStyle::OutlineMapper
| protected

Definition at line 459 of file vtkInteractorStyle.h.

## ◆ OutlineActor

vtkActor* vtkInteractorStyle::OutlineActor
| protected

Definition at line 460 of file vtkInteractorStyle.h.

## ◆ PickedRenderer

vtkRenderer* vtkInteractorStyle::PickedRenderer
| protected

Definition at line 461 of file vtkInteractorStyle.h.

## ◆ CurrentProp

vtkProp* vtkInteractorStyle::CurrentProp
| protected

Definition at line 462 of file vtkInteractorStyle.h.

## ◆ PickedActor2D

vtkActor2D* vtkInteractorStyle::PickedActor2D
| protected

Definition at line 463 of file vtkInteractorStyle.h.

## ◆ PropPicked

int vtkInteractorStyle::PropPicked
| protected

Definition at line 464 of file vtkInteractorStyle.h.

## ◆ PickColor

double vtkInteractorStyle::PickColor[3]
| protected

Definition at line 465 of file vtkInteractorStyle.h.

## ◆ MouseWheelMotionFactor

double vtkInteractorStyle::MouseWheelMotionFactor
| protected

Definition at line 466 of file vtkInteractorStyle.h.

## ◆ TimerDuration

unsigned long vtkInteractorStyle::TimerDuration
| protected

Definition at line 469 of file vtkInteractorStyle.h.

## ◆ EventForwarder

vtkEventForwarderCommand* vtkInteractorStyle::EventForwarder
| protected

Definition at line 472 of file vtkInteractorStyle.h.

## ◆ TDxStyle

vtkTDxInteractorStyle* vtkInteractorStyle::TDxStyle
| protected

Definition at line 474 of file vtkInteractorStyle.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkInteractorStyle.h